unit VGA;

interface

Const MaxX = 319;
      MaxY = 199;

type Color_Type = record
     Red:   Byte;
     Green: Byte;
     Blue:  Byte;
end;
     Color_Table = Array [Byte] of Color_Type;
     VGA_Linear = Array [0..63999] of Byte;
     VGA_Array = Array [0..MaxY, 0..MaxX] of Byte;

var Screen_Linear : VGA_Linear Absolute $A000:$0000;
    Screen_Array  : VGA_Array  Absolute $A000:$0000;

procedure InitVGA;
procedure CloseVGA;
procedure GetPalette(var P: Color_Table);
procedure PutPalette(P: Color_Table);

implementation

uses Dos;

procedure InitVGA;
begin
     asm
        MOV AX, 13H
        INT 10H
     end;
end;

procedure CloseVGA;
begin
     asm
        mov AX, 03H
        INT 10H
     end;
end;

procedure GetPalette(var P: Color_Table);
var R: Registers;
begin
     FillChar(R, SizeOf(R), 0);
     with R do begin
          AX := $1017;
          BX := 0;
          CX := 256;
          ES := Seg(P);
          DX := Ofs(P);
     end;

     Intr($10, R);
end;

procedure PutPalette(P: Color_Table);
var R: Registers;
begin
     FillChar(R, SizeOf(R), 0);
     with R do begin
          AX := $1012;
          BX := 0;
          CX := 256;
          ES := Seg(P);
          DX := Ofs(P);
     end;

     Intr($10, R);
end;

end.